using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Airbus
{
    public partial class FormAirbus : Form
    {
        private DrawningAirbus _airbus;

        // 
        public DrawningAirbus SelectedPlane { get; set; }
        public FormAirbus()
        {
            InitializeComponent();
        }
        //  
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxAirbus.Width, pictureBoxAirbus.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _airbus?.DrawTransport(gr);
            pictureBoxAirbus.Image = bmp;
        }

        //  
        private void SetData()
        {
            Random rnd = new();
            toolStripStatusLabelSpeed.Text = $": {_airbus.Airbus?.Speed}";
            toolStripStatusLabelWeight.Text = $": {_airbus.Airbus?.Weight}";
            toolStripStatusLabelCorpusColor.Text = $": {_airbus.Airbus?.CorpusColor.Name}";
            _airbus.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxAirbus.Width, pictureBoxAirbus.Height);
        }
        //   ""
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }

            _airbus = new DrawningAirbus(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
            SetData();
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _airbus?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _airbus?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _airbus?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _airbus?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }

        //   
        private void PictureBoxAirbus_Resize(object sender, EventArgs e)
        {
            _airbus?.ChangeBorders(pictureBoxAirbus.Width, pictureBoxAirbus.Height);
            Draw();
        }

        //   ""
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }

            Color addColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogAdd = new();

            if (dialogAdd.ShowDialog() == DialogResult.OK)
            {
                addColor = dialogAdd.Color;
            }

            _airbus = new DrawningSuperAirbus(rnd.Next(100, 300), rnd.Next(1000, 2000), color, addColor,
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }
        private void buttonSelectPlane_Click(object sender, EventArgs e)
        {
            SelectedPlane = _airbus;
            DialogResult = DialogResult.OK;
        }
    }
}